#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>
#include <hamsandwich>

#if AMXX_VERSION_NUM < 183
	#include <dhudmessage>
#endif

#define PLUGIN "Simple VIP"
#define VERSION "Final"
#define AUTHOR "ArtHa"

#define VIP ADMIN_LEVEL_H
#define TID_REMOVE 2551
#define REMOVE_TIME 20.05

new bool:gVipmenuActive[33];
new bool:HasC4[33];
new g_pHp[ 3 ];

new bool:gShopVipmenu = true;
new CurrentRound, VipmenuRound, PistolsChoose;
new AwpForVip, LimitAwp, PlayerLimit;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_dictionary("simple_vip.txt");
	new configsdir[64], file[132];
	get_configsdir(configsdir, 63);
	format(file, 131, "%s/blockedmaps.ini", configsdir)	;
	load_maps(file);
	
	register_logevent("logevent_round_end", 2, "1=Round_End"); 
	register_event( "TextMsg","round_restart","a","2&#Game_C", "2&#Game_W" );
	RegisterHam( Ham_Spawn, "player", "FnHamSpawn", 1 );
	
	VipmenuRound = register_cvar( "vipmenu_round", "2" );
	PistolsChoose = register_cvar( "vipmenu_pistols", "1" );
	AwpForVip = register_cvar( "vip_awp", "1" );
	LimitAwp = register_cvar( "awp_limit", "1" );
	PlayerLimit = register_cvar( "player_limit", "8" );
	
	g_pHp[ 0 ] = register_cvar( "amx_vip_hpadd", "10" );
	g_pHp[ 1 ] = register_cvar( "amx_vip_hsadd", "20" );
	g_pHp[ 2 ] = register_cvar( "amx_vip_hpmax", "100" );
}

public load_maps(path[])
{
	new szMapname[64], szMap[64];
	new file = fopen(path, "rt");

	if(!file)
	{
		server_print("Nepavyko rasti blockedmaps.ini failo!");
		return PLUGIN_HANDLED;
	}

	new iSize = file_size(path, 1);

	for(new i = 0, iLen; i < iSize; i++)
	{
		read_file(path, i, szMapname, charsmax(szMapname), iLen);

		if(equal(szMapname[0], "") || equal(szMapname[0], ";"))
		{
			continue;
		}
		
		get_mapname(szMap, 63);
		if(equali(szMap, szMapname))
		{
			gShopVipmenu = false;
			break;
		}
	}
	fclose(file);
	return PLUGIN_CONTINUE;
}

public plugin_cfg()
{
	new cfgdir[32];
	get_configsdir(cfgdir, charsmax(cfgdir));
	
	server_cmd("exec %s/simple_vip.cfg", cfgdir);
}

public logevent_round_end()
{
	CurrentRound++;
	return PLUGIN_HANDLED;
}

public round_restart()
{
	CurrentRound = 1;
	return PLUGIN_HANDLED;
}

public FnHamSpawn(id)
{
	if( !( is_user_alive( id ) ) || !gShopVipmenu )
		return PLUGIN_HANDLED;

	if(get_user_flags(id) & VIP )
	{
		if( gVipmenuActive[ id ] )
			gVipmenuActive[ id ] = false;
		
		if(task_exists(TID_REMOVE+id))
			remove_task(TID_REMOVE+id);
		
		gVipmenuActive[ id ] = true;
		set_task(REMOVE_TIME, "Close", TID_REMOVE+id );
		vipmenu( id );
	}
	
	return PLUGIN_HANDLED;
}

public Close(tid)
{
	static id;
	id = tid-TID_REMOVE;
	
	if(gVipmenuActive[ id ] )
	{
		client_cmd( id, "slot10" );
		gVipmenuActive[ id ] = false;
		ChatColor( id, "%L", id, "CLOSED" );
	}
}

public vipmenu( id ) 
{
	if( get_pcvar_num(PistolsChoose) < 1 && CurrentRound < get_pcvar_num( VipmenuRound ) )
		return PLUGIN_HANDLED;
	
	new buffer[1024];
	formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "VIPMENU");				
	new menu = menu_create(buffer, "menu_handler");
	
	if(CurrentRound < get_pcvar_num( VipmenuRound ) )
	{
		formatex(buffer, charsmax(buffer), "%L", id, "GUN1");
		menu_additem(menu, buffer, "1", 0);
		formatex(buffer, charsmax(buffer), "%L", id, "GUN2");
		menu_additem(menu, buffer, "2", 0);
		formatex(buffer, charsmax(buffer), "%L", id, "GUN3");
		menu_additem(menu, buffer, "3", 0);
	}
	else if(CurrentRound >= get_pcvar_num( VipmenuRound ) )
	{
		formatex(buffer, charsmax(buffer), "%L", id, "WEAPONS1");
		menu_additem(menu, buffer, "4", 0);
		formatex(buffer, charsmax(buffer), "%L", id, "WEAPONS2");
		menu_additem(menu, buffer, "5", 0);
		formatex(buffer, charsmax(buffer), "%L", id, "WEAPONS3");
		menu_additem(menu, buffer, "6", 0);
		formatex(buffer, charsmax(buffer), "%L", id, "WEAPONS4");
		menu_additem(menu, buffer, "7", 0);
	}
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);
	menu_display(id, menu, 0);
	
	return PLUGIN_HANDLED;
}

public menu_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		give_items(id);
		gVipmenuActive[ id ] = false;
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new data[6], iName[64];
	new acess, callback;
   
	menu_item_getinfo(menu, item, acess, data,6, iName, 63, callback);
	new key = str_to_num(data);
	
	switch(key)
	{	
		case 1: { give_weapon(id, CSW_GLOCK18, 120 ); }
		case 2: { give_weapon(id, CSW_USP, 100 ); }		
		case 3: { give_weapon(id, CSW_DEAGLE, 35 ); }
		case 4: { give_weapons(id, CSW_M4A1, 90, CSW_DEAGLE, 35 ); }
		case 5: { give_weapons(id, CSW_AK47, 90, CSW_DEAGLE, 35 ); }
		case 6: { give_weapons(id, CSW_FAMAS, 90, CSW_DEAGLE, 35 ); }
		case 7: { give_weapons(id, CSW_AWP, 30, CSW_DEAGLE, 35 ); }
	}
	
	gVipmenuActive[id] = false;
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public give_weapons(id, prim, ammo1, sec, ammo2)
{
	if( !( is_user_alive( id ) ) )
		return PLUGIN_HANDLED;
		
	HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1);
	
	new weapon[32];
	strip_user_weapons (id);
	get_weaponname(prim, weapon, 31);
	give_item(id,weapon);
	cs_set_user_bpammo(id, prim, ammo1);
 
	get_weaponname(sec, weapon, 31);
	give_item(id,weapon);
	cs_set_user_bpammo(id, sec, ammo2);
 
	give_item(id,"weapon_knife");
    
	if(HasC4[id])
	{
		give_item(id, "weapon_c4");
		cs_set_user_plant( id );
	}
	
	give_items(id);
	
	return PLUGIN_HANDLED;
}

public give_weapon(id, sec, ammo)
{
	if( !( is_user_alive( id ) ) )
		return PLUGIN_HANDLED;
		
	HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1);

	new weapon[32];
	strip_user_weapons (id);
	get_weaponname(sec, weapon, 31);
	give_item(id,weapon);
	cs_set_user_bpammo(id, sec, ammo);
 
	give_item(id,"weapon_knife");
    
	if (HasC4[id])
	{
		give_item(id, "weapon_c4");
		cs_set_user_plant( id );
	}
	
	give_items(id);
	
	return PLUGIN_HANDLED;
}

public give_items(id)
{
	if( is_user_alive(id) )
	{
		give_item(id, "weapon_hegrenade");
		give_item(id, "weapon_smokegrenade");
		give_item(id, "weapon_flashbang");
		cs_set_user_bpammo(id, CSW_FLASHBANG, 2);
		give_item(id, "item_assaultsuit");
		
		if(get_user_team(id) == 2)
			give_item(id, "item_thighpack");
	}
}

public Event_DeathMsg( )
{
	new iKiller = read_data( 1 );
	new iVictim = read_data( 2 );
	new HeadShot = read_data( 3 );
	
	if( get_user_team( iKiller ) == get_user_team( iVictim ) )
		return;
	
	if( iKiller && iVictim != iKiller && get_user_flags(iKiller) & VIP )
	{
		static maxhp, hp;
		maxhp = get_pcvar_num( g_pHp[ 2 ] );
		hp = get_user_health( iKiller );
		
		if( hp != maxhp )
		{
			new BonusHp;
			if( HeadShot ) BonusHp = get_pcvar_num( g_pHp[ 1 ] );
			else BonusHp = get_pcvar_num( g_pHp[ 0 ] );
			
			if( hp + BonusHp > maxhp )
			{
				set_user_health( iKiller, maxhp );
				
				set_dhudmessage( 0,255,0, -1.0, 0.15, 1, 1.0, 1.0, 0.1, 0.2);
				show_dhudmessage(iKiller, "%L", iKiller, "HP_BONUS", maxhp - hp )	;
			}
			else
			{
				set_user_health( iKiller, hp + BonusHp );
				set_dhudmessage( 0,255,0, -1.0, 0.15, 1, 1.0, 1.0, 0.1, 0.2);
				show_dhudmessage(iKiller, "%L", iKiller, "HP_BONUS", BonusHp );
			}
		}
	}	
}

public event_CurWeapon(id)
{
	switch(read_data(2))
	{
		case CSW_AWP, CSW_SG550, CSW_G3SG1:
		{
			if( !get_user_flags(id) & !ADMIN_LEVEL_H && get_pcvar_num(AwpForVip) >= 1 )
			{
				HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1);
				strip_user_weapons (id);
				give_item(id,"weapon_knife");
    
				if(HasC4[id])
				{
					give_item(id, "weapon_c4");
					cs_set_user_plant( id );
				}
				
				if( get_user_team(id) == 1 )
					give_weapon(id, CSW_GLOCK18, 120 );
				else
					give_weapon(id, CSW_USP, 100 );
				
				ChatColor(id, "%L", id, "AWP_VIP" );
			}

			if(get_pcvar_num(LimitAwp) >= 1 && get_playersnum() < get_pcvar_num(PlayerLimit)) // psychical code
			{
				HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1);
				strip_user_weapons (id);
				give_item(id,"weapon_knife");
    
				if(HasC4[id])
				{
					give_item(id, "weapon_c4");
					cs_set_user_plant( id );
				}
				
				if( get_user_team(id) == 1 )
					give_weapon(id, CSW_GLOCK18, 120 );
				else
					give_weapon(id, CSW_USP, 100 );
				
				ChatColor(id, "%L", id, "AWP_LIMIT" );
			}
		}
	}
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32];
    static msg[192];
    vformat(msg, 191, input, 3);
   
    replace_all(msg, 191, "!g", "^4");
    replace_all(msg, 191, "!y", "^1");
    replace_all(msg, 191, "!t", "^3");
   
    if (id) players[0] = id; else get_players(players, count, "ch");
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
}